"""
    EMIL AccountService

    The EMIL AccountService API description  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@emil.de
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from eis.account.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from eis.account.exceptions import ApiAttributeError


def lazy_import():
    from eis.account.model.policy_class import PolicyClass
    globals()['PolicyClass'] = PolicyClass


class AccountClass(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('title',): {
            'EMPTY': "",
            'DR.': "Dr.",
            'DR._MED.': "Dr. med.",
            'PROF._DR._MED.': "Prof. Dr. med.",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (float,),  # noqa: E501
            'code': (str,),  # noqa: E501
            'account_number': (str,),  # noqa: E501
            'first_name': (str,),  # noqa: E501
            'last_name': (str,),  # noqa: E501
            'email': (str,),  # noqa: E501
            'gender': (str,),  # noqa: E501
            'street': (str,),  # noqa: E501
            'house_number': (str,),  # noqa: E501
            'zip_code': (str,),  # noqa: E501
            'city': (str,),  # noqa: E501
            'phone': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'version': (float,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
            'policies': ([PolicyClass],),  # noqa: E501
            'ern': (str,),  # noqa: E501
            'title': (str,),  # noqa: E501
            'birth_date': (datetime,),  # noqa: E501
            'company_name': (str,),  # noqa: E501
            'metadata': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'custom_fields': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'code': 'code',  # noqa: E501
        'account_number': 'accountNumber',  # noqa: E501
        'first_name': 'firstName',  # noqa: E501
        'last_name': 'lastName',  # noqa: E501
        'email': 'email',  # noqa: E501
        'gender': 'gender',  # noqa: E501
        'street': 'street',  # noqa: E501
        'house_number': 'houseNumber',  # noqa: E501
        'zip_code': 'zipCode',  # noqa: E501
        'city': 'city',  # noqa: E501
        'phone': 'phone',  # noqa: E501
        'type': 'type',  # noqa: E501
        'version': 'version',  # noqa: E501
        'created_at': 'createdAt',  # noqa: E501
        'updated_at': 'updatedAt',  # noqa: E501
        'policies': 'policies',  # noqa: E501
        'ern': 'ern',  # noqa: E501
        'title': 'title',  # noqa: E501
        'birth_date': 'birthDate',  # noqa: E501
        'company_name': 'companyName',  # noqa: E501
        'metadata': 'metadata',  # noqa: E501
        'custom_fields': 'customFields',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, code, account_number, first_name, last_name, email, gender, street, house_number, zip_code, city, phone, type, version, created_at, updated_at, policies, ern, *args, **kwargs):  # noqa: E501
        """AccountClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            account_number (str): Optional field in order to use a specific account number.
            first_name (str): The account's first name.
            last_name (str): The account's last name.
            email (str): The account's email address,      It is displayed alongside the account in your dashboard      and can be useful for searching and tracking.
            gender (str): The account's gender.
            street (str): The account's street name.
            house_number (str): The account's house number.
            zip_code (str): The account's ZIP or postal code
            city (str): The account's city, district, suburb, town, or village.
            phone (str): The account's phone number.
            type (str): The type of account, default to person
            version (float): The account's version.
            created_at (datetime): Time at which the object was created.
            updated_at (datetime): Time at which the object was updated.
            policies ([PolicyClass]): Policies linked to the account.
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (str): The account's title.. [optional]  # noqa: E501
            birth_date (datetime): The account's date of birth. required for account type person. [optional]  # noqa: E501
            company_name (str): The company name of account, required for account type org. [optional]  # noqa: E501
            metadata ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional field contain extra information.. [optional]  # noqa: E501
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional field contain custom fields.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.account_number = account_number
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.gender = gender
        self.street = street
        self.house_number = house_number
        self.zip_code = zip_code
        self.city = city
        self.phone = phone
        self.type = type
        self.version = version
        self.created_at = created_at
        self.updated_at = updated_at
        self.policies = policies
        self.ern = ern
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, code, account_number, first_name, last_name, email, gender, street, house_number, zip_code, city, phone, type, version, created_at, updated_at, policies, ern, *args, **kwargs):  # noqa: E501
        """AccountClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            account_number (str): Optional field in order to use a specific account number.
            first_name (str): The account's first name.
            last_name (str): The account's last name.
            email (str): The account's email address,      It is displayed alongside the account in your dashboard      and can be useful for searching and tracking.
            gender (str): The account's gender.
            street (str): The account's street name.
            house_number (str): The account's house number.
            zip_code (str): The account's ZIP or postal code
            city (str): The account's city, district, suburb, town, or village.
            phone (str): The account's phone number.
            type (str): The type of account, default to person
            version (float): The account's version.
            created_at (datetime): Time at which the object was created.
            updated_at (datetime): Time at which the object was updated.
            policies ([PolicyClass]): Policies linked to the account.
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (str): The account's title.. [optional]  # noqa: E501
            birth_date (datetime): The account's date of birth. required for account type person. [optional]  # noqa: E501
            company_name (str): The company name of account, required for account type org. [optional]  # noqa: E501
            metadata ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional field contain extra information.. [optional]  # noqa: E501
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional field contain custom fields.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.account_number = account_number
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.gender = gender
        self.street = street
        self.house_number = house_number
        self.zip_code = zip_code
        self.city = city
        self.phone = phone
        self.type = type
        self.version = version
        self.created_at = created_at
        self.updated_at = updated_at
        self.policies = policies
        self.ern = ern
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
